//
// FILE: sampdll.cpp
//
// Copyright (c) 1997 by Aaron Michael Cohen and Mike Woodring
//
/////////////////////////////////////////////////////////////////////////

#include <windows.h>

#define EXPORT_SAMPDLL_API
#include "sampdll.h"

class CFoo
{
    public:
        CFoo( int iInstance )
            : m_iInstance(iInstance)
        {
            wsprintf(m_szMsgBuf, __TEXT("CFoo::CFoo(%d)\n"), m_iInstance);
            OutputDebugString(m_szMsgBuf);
        }

        ~CFoo()
        {
            wsprintf(m_szMsgBuf, __TEXT("CFoo::~CFoo(%d)\n"), m_iInstance);
            OutputDebugString(m_szMsgBuf);
        }
    
    private:
        int     m_iInstance;
        TCHAR   m_szMsgBuf[80];
};

CFoo    Foo(1);
CFoo    AnotherFoo(2);

BOOL WINAPI DllMain
(
    HANDLE  hInst, 
    ULONG   dwReason,
    LPVOID  lpReserved
)
{
    switch( dwReason )
    {
        case DLL_PROCESS_ATTACH:
            OutputDebugString(__TEXT("DLL_PROCESS_ATTACH\n"));

            if( lpReserved )
            {   
                OutputDebugString(__TEXT("lpReserved != NULL\n"));
            }
            else
            {
                OutputDebugString(__TEXT("lpReserved == NULL\n"));
            }
        break;

        case DLL_THREAD_ATTACH:
            OutputDebugString(__TEXT("DLL_THREAD_ATTACH\n"));
        break;

        case DLL_THREAD_DETACH:
            OutputDebugString(__TEXT("DLL_THREAD_DETACH\n"));
        break;

        case DLL_PROCESS_DETACH:
            OutputDebugString(__TEXT("DLL_PROCESS_DETACH\n"));
        break;
    }

    // Return FALSE to cause the load for sampdll.dll to fail.
    //
    return(TRUE);
}

SAMPDLL_API void __stdcall SayHello( void )
{
    OutputDebugString(__TEXT("Hello from sampdll.dll!\n"));
}
