#include <stdio.h>
#include <tchar.h>
#include "CMcl.h"

#define MAILBOX_NAME        __TEXT("CMailboxDemoMailbox")
#define MAILBOX_DEPTH       100
#define MAILBOX_MSG_SIZE    sizeof(DWORD)
#define MAILBOX_TIMEOUT     5

class CMclMailboxReader : public CMclThreadHandler {
private:
    CMclMailbox m_cMailbox;
    BOOLEAN m_bRun;

public:
    // class constructor initializes the mailbox object...
    CMclMailboxReader( LPCTSTR lpszName) :
        m_cMailbox( MAILBOX_DEPTH, MAILBOX_MSG_SIZE, lpszName) {
            m_bRun = TRUE;
            return;
    }

    virtual unsigned ThreadHandlerProc(void) {
        while (m_bRun) {
            DWORD dwMsg = 0;
            if (m_cMailbox.Get( &dwMsg, INFINITE)) {
                // message read succeeded...
				if (dwMsg == 0) {
                printf( "Mailbox reader thread id 0x%08x read %d.\n",
                    GetCurrentThreadId(), dwMsg);
				}
            }
            else {
                // message read failed...
                printf( "Mailbox reader thread id 0x%08x timed out.\n",
                    GetCurrentThreadId(), dwMsg);
            }
        }
        return 0;
    }

    void Stop(void) {
        m_bRun = FALSE;
    }
};

class CMclMailboxWriter : public CMclThreadHandler {
private:
    CMclMailbox m_cMailbox;
    BOOLEAN m_bRun;

public:
    // class constructor initializes the mailbox object...
    CMclMailboxWriter( LPCTSTR lpszName) :
        m_cMailbox( MAILBOX_DEPTH, MAILBOX_MSG_SIZE, lpszName) {
            m_bRun = TRUE;
            return;
    }

    virtual unsigned ThreadHandlerProc(void) {
        DWORD dwMsg = 1;
        while (m_bRun) {
			Sleep (250);
            if (m_cMailbox.Post( &dwMsg, MAILBOX_TIMEOUT)) {
                dwMsg++;
            }
            else {
                // message post failed...
                printf( "Mailbox writer thread id 0x%08x timed out, will repost %d.\n",
                    GetCurrentThreadId(), dwMsg);
            }
        }
        return 0;
    }

    void Stop(void) {
        m_bRun = FALSE;
    }
};

int main( int argc, char *argv[]) {
    CMclMailboxWriter cWriter1(MAILBOX_NAME);
    CMclThreadAutoPtr apWriter1Thread = new CMclThread(&cWriter1);
    CMclMailboxWriter cWriter2(MAILBOX_NAME);
    CMclThreadAutoPtr apWriter2Thread = new CMclThread(&cWriter2);
/*
    CMclMailboxWriter cWriter3(MAILBOX_NAME);
    CMclThreadAutoPtr apWriter3Thread = new CMclThread(&cWriter3);
    CMclMailboxWriter cWriter4(MAILBOX_NAME);
    CMclThreadAutoPtr apWriter4Thread = new CMclThread(&cWriter4);
    CMclMailboxWriter cWriter5(MAILBOX_NAME);
    CMclThreadAutoPtr apWriter5Thread = new CMclThread(&cWriter5);
*/
    CMclMailboxReader cReader(MAILBOX_NAME);
    CMclThreadAutoPtr apReaderThread = new CMclThread(&cReader);

    while (1)
		Sleep(1000);

    return 0;
}


